#!/bin/bash

if [ ! -x /Library/Frameworks/XUL.framework/xulrunner-bin ]; then
    echo "The installation of Lucidor failed. XULRunner must be installed before Lucidor can be installed."
    exit 1
fi

[ "$0" != "bash" ] && cd "${0%/*}"

if [ -r lucidor/application.ini ]; then
    /Library/Frameworks/XUL.framework/xulrunner-bin --install-app lucidor
else
    /Library/Frameworks/XUL.framework/xulrunner-bin --install-app Lucidor.zip
fi

ERROR=$?
if [ $ERROR == 0 ]; then
    MSG="The installation was successful. You can now run Lucidor by clicking on Lucidor in the Ordbrand folder."
else
    MSG="The installation of Lucidor failed for an unknown reason. Errorcode: $ERROR"
fi
echo $MSG
