@echo off

rem  To manually configure which installation of Pale Moon or XULRunner to use
rem  you need to set either the PALEMOON or the XULRUNNER variable.
rem  The line "set PALEMOON=" should point to the installation folder of
rem  Pale Moon. For example: "set PALEMOON=C:\\Program Files\Pale Moon".
rem  Alternatively, the line "set XULRUNNER=" should point to the installation
rem  folder of XULRunner.

setlocal

set EXE=
set PALEMOON=
set FIREFOX=
set XULRUNNER=


rem  Read command line arguments

set LUCIDOR=%~dp0

set ARGS=
:argloop
shift
if [%0]==[] goto endloop
if [%0]==[-d] goto debug
set ARGS=%ARGS% %0
goto argloop
:debug
set ARGS=%ARGS% -jsconsole -console
goto argloop

:endloop

if exist "%EXE%" goto run_exe
if exist "%PALEMOON%\palemoon.exe" goto run_palemoon
if exist "%FIREFOX%\firefox.exe" goto run_firefox
if exist "%XULRUNNER%\xulrunner.exe" goto run_xulrunner


rem  Check registry for Pale Moon

for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Mozilla\Pale Moon"') do (
    if "%%a"=="CurrentVersion" set PMVER=%%c
)
if not defined PMVER goto pm_sixtyfour
for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Mozilla\Pale Moon\%PMVER%\Main"') do (
    if "%%a"=="PathToExe" set EXE=%%c
)
if defined EXE goto run_exe

:pm_sixtyfour
for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Mozilla\Pale Moon"') do (
    if "%%a"=="CurrentVersion" set PMVER=%%c
)
if not defined PMVER goto ff_test
for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Mozilla\Pale Moon\%PMVER%\Main"') do (
    if "%%a"=="PathToExe" set EXE=%%c
)
if defined EXE goto run_exe


rem  Check registry for Firefox

:ff_check
for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Mozilla\Mozilla Firefox"') do (
    if "%%a"=="CurrentVersion" set FFVER=%%c
)
if not defined FFVER goto ff_sixtyfour
for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Mozilla\Mozilla Firefox\%FFVER%\Main"') do (
    if "%%a"=="PathToExe" set EXE=%%c
)
if defined EXE goto run_exe

:ff_sixtyfour
for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Mozilla\Mozilla Firefox"') do (
    if "%%a"=="CurrentVersion" set FFVER=%%c
)
if not defined FFVER goto dir_test
for /f "tokens=1,2*" %%a in ('reg query "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Mozilla\Mozilla Firefox\%FFVER%\Main"') do (
    if "%%a"=="PathToExe" set EXE=%%c
)
if defined EXE goto run_exe


rem  Check possible installation folders for Firefox

:dir_test
if not defined ProgramFiles goto dir_testx

for /d %%a in ("%ProgramFiles%\*Firefox*") do (
    if exist "%%a\firefox.exe" set FIREFOX_DIR=%%a
)
set FIREFOX=%FIREFOX_DIR%
if defined FIREFOX_DIR goto run_firefox

:dir_testx
if not defined ProgramFiles(x86) goto dir_testy

for /d %%a in ("%ProgramFiles(x86)%\*Firefox*") do (
    if exist "%%a\firefox.exe" set FIREFOX_DIR=%%a
)
set FIREFOX=%FIREFOX_DIR%
if defined FIREFOX_DIR goto run_firefox

:dir_testy
for /d %%a in ("C:\\Program Files\*Firefox*") do (
    if exist "%%a\firefox.exe" set FIREFOX_DIR=%%a
)
set FIREFOX=%FIREFOX_DIR%
if defined FIREFOX_DIR goto run_firefox


rem  Check common installation folders

set PALEMOON=C:\\Program Files\Pale Moon
if exist "%PALEMOON%\palemoon.exe" goto run_palemoon

set PALEMOON=C:\\Program Files (x86)\Pale Moon
if exist "%PALEMOON%\palemoon.exe" goto run_palemoon

set XULRUNNER=.\xulrunner
if exist "%XULRUNNER%\xulrunner.exe" goto run_xulrunner

set XULRUNNER=C:\\Program Files\xulrunner
if exist "%XULRUNNER%\xulrunner.exe" goto run_xulrunner

set FIREFOX=C:\\Program Files\Mozilla Firefox
if exist "%FIREFOX%\firefox.exe" goto run_firefox

goto end


:run_xulrunner
start "Lucidor" /b "%XULRUNNER%\xulrunner.exe" "%LUCIDOR%lucidor\application.ini" %ARGS%
goto end

:run_palemoon
start "Lucidor" /b "%PALEMOON%\palemoon.exe" -app "%LUCIDOR%lucidor\application.ini" %ARGS%
goto end

:run_firefox
start "Lucidor" /b "%FIREFOX%\firefox.exe" -app "%LUCIDOR%lucidor\application.ini" %ARGS%
goto end

:run_exe
start "Lucidor" /b "%EXE%" -app "%LUCIDOR%lucidor\application.ini" %ARGS%
goto end

:end
endlocal
